
#include "CAuZlibEncoder.h"

VOID CAuZlibEncoder::Encode(HANDLE hInFile, HANDLE hOutFile, DWORD dwInputSize, FPKENTRY *lpEntry)
{
	BYTE *pInBuffer, *pOutBuffer;
	DWORD dwOutSize, dwOutputSize, dwDummy;

	WriteFile(hOutFile, &dwInputSize, sizeof(DWORD), &dwDummy, NULL);

	pInBuffer = new BYTE[dwInputSize];
	ReadFile(hInFile, pInBuffer, dwInputSize, &dwDummy, NULL);
	dwOutputSize = dwInputSize * (9 / 8) + 1024;
	pOutBuffer = new BYTE[dwOutputSize];		// o̓TCYς

	dwOutSize = ZlibEncode(pInBuffer, dwInputSize, pOutBuffer, dwOutputSize);
	WriteFile(hOutFile, pOutBuffer, dwOutSize, &dwDummy, NULL);

	delete [] pInBuffer;
	delete [] pOutBuffer;

	lpEntry->dwSize = dwOutSize + 4;
	lpEntry->szFileName[15] = FPK_ZLIB_COMPRESSION;
}

DWORD CAuZlibEncoder::ZlibEncode(BYTE *inptr, DWORD size, BYTE *code, DWORD dwOutputSize)
{
	z_stream z;								/* CuƂƂ肷邽߂̍\ */
	int status;

	/* ׂẴǗCuɔC */
	z.zalloc = Z_NULL;
	z.zfree = Z_NULL;
	z.opaque = Z_NULL;
	if(deflateInit2_(&z, 9, Z_DEFLATED, 10, /* DEF_MEM_LEVEL = */ 8,
			Z_DEFAULT_STRATEGY, ZLIB_VERSION, sizeof(z_stream)) != Z_OK)
		return (DWORD)-1;

	z.avail_in = 0;						/* ̓obt@̃f[^̃oCg */
	z.next_in = inptr;				/* ̓|C^̓obt@̐擪 */
	z.avail_in = size;				/* f[^ǂݍ */
	z.next_out = code;				/* o̓|C^ */
	z.avail_out = dwOutputSize;	/* o̓obt@̃TCY */

	/* ʏ deflate() ̑2 Z_NO_FLUSH ɂČĂяo */

	while(1)
	{
		status = deflate(&z, Z_FINISH);				/* k */
		if(status == Z_STREAM_END)	break;			/*  */
		if(status != Z_OK)
			return (DWORD)-1;
	}

	/* n */
	if(deflateEnd(&z) != Z_OK)
		return (DWORD)-1;

	return dwOutputSize - z.avail_out;
}
