/*
	* libfpk -- using FPK archive on P/ECE
	* 	By Yui N., 2003.
	* http://www.autch.net/
*/

#include <piece.h>
#include <muslib.h>
#include "../libfpk.h"

static unsigned char vScreen[128 * 88];
static unsigned char DrawFlag;

unsigned char *pSeq = NULL;
HFPK hfpk = NULL;
int MusicIndex = 0;

void Cls()
{
	memset(vScreen, 0, 128 * 88);
	pceFontSetPos(0, 0);
	DrawFlag = 1;
}

void Refresh()
{
	if(DrawFlag)
	{
		pceLCDTrans();
		DrawFlag = 0;
	}
}

void Sleep(unsigned int ms)
{
	unsigned int s = pceTimerGetCount();
	while(pceTimerGetCount() - s < ms)
		;
}

void pceAppInit()
{
	pceLCDDispStop();
	pceLCDSetBuffer(vScreen);
	pceAppSetProcPeriod(50);

	InitMusic();
	Cls();
	{
		FPKENTRY fpkEntry;

		if((hfpk = fpkOpenArchive("mypmds.par")) == NULL)
		{
			pceAppReqExit(-1);
			return;
		}

		fpkGetFileInfoN(hfpk, MusicIndex, &fpkEntry);
		pceFontSetPos(0, 0);	pceFontPrintf("%-16s", fpkEntry.szFileName);
		pSeq = fpkExtractToBuffer(hfpk, &fpkEntry);
		StopMusic();
		Sleep(10);												// ی
		pceWaveAbort(music_wch);
		Sleep(160);												// ی
		PlayMusic(pSeq);
	}

	pceLCDDispStart();
}

void pceAppProc(int cnt)
{
	FPKENTRY fpkEntry;

	if(pcePadGet() & TRG_A)
	{
		if(pSeq != NULL)	pceHeapFree(pSeq);
		fpkGetFileInfoN(hfpk, MusicIndex, &fpkEntry);
		pSeq = fpkExtractToBuffer(hfpk, &fpkEntry);
		StopMusic();
		Sleep(10);												// ی
		pceWaveAbort(music_wch);
		Sleep(160);												// ی
		PlayMusic(pSeq);
	}
	if(pcePadGet() & TRG_B)
	{
		if(pSeq != NULL)
		{
			pceHeapFree(pSeq);
			pSeq = NULL;
		}
		StopMusic();
		pceWaveAbort(music_wch);
	}
	if(pcePadGet() & TRG_LF)
	{
		if(MusicIndex > 0)	MusicIndex--;
		fpkGetFileInfoN(hfpk, MusicIndex, &fpkEntry);
		pceFontSetPos(0, 0);	pceFontPrintf("%-16s", fpkEntry.szFileName);
		DrawFlag = 1;
	}
	if(pcePadGet() & TRG_RI)
	{
		if(MusicIndex < hfpk->fpkHeader.dwFilesAmount - 1)	MusicIndex++;
		fpkGetFileInfoN(hfpk, MusicIndex, &fpkEntry);
		pceFontSetPos(0, 0);	pceFontPrintf("%-16s", fpkEntry.szFileName);
		DrawFlag = 1;
	}
	pceAppActiveResponse(MusicCheck() ? AAR_NOACTIVE : AAR_ACTIVE);

	Refresh();
}

void pceAppExit()
{
	if(pSeq != NULL)
	{
		pceHeapFree(pSeq);
		pSeq = NULL;
	}
	StopMusic();
	pceWaveAbort(music_wch);
	fpkCloseArchive(hfpk);
}
